function Ratio = Calibration(image)
    figure1=figure();
    imshow(image);
    split = strsplit(image,'\');
    name = split(end);
    title("Calibration Image: "+name+" ");
    set(gcf, 'Position', get(0,'Screensize')); % Maximize figure.
    message = sprintf('Click on two neighbouring crossmarks.\nEnter to finish');
    uiwait(msgbox(message));
    [xi,yi] = getpts;
    d_pix = sqrt((xi(2)-xi(1))^2 + (yi(2)-yi(1))^2 );
    d_real = input('What is the real distance between the two marked points? [um micrometer]  ');
    
    Ratio = d_real / d_pix;   % pix / um;
    
    disp("Ratio = "+num2str(Ratio)+" [um/pixel]")
end 