clear all
close all
clc

%% Import Video
name = 'D:\NTNU\10. Semester - MASTER\Spiral IDT\09.05.2023 - single system 80 MHz\80MHz-Exp28_09052023_120MHz_2uL_7ump_conc_1_5_200mW_4xMag_60fps'; %%- INPUT -%%
a = VideoReader([name '.mp4'])
% Adjust the starting frame in line 23

%% Where to save the images
path = 'D:\NTNU\10. Semester - MASTER\Spiral IDT\09.05.2023 - single system 80 MHz\09.05.2023 Images\'; % path where images will be saved

A = split(name,'\');
save_name = append(path,A(end));
%% Mask ROI

% Draw the elliptical mask
frame = read(a,1);
imshow(frame);
title('Original Grayscale Image');
h = drawellipse('Center',[985 600],'SemiAxes',[830 750],'RotationAngle',-10,'StripeColor','m');  %%- INPUT -%% Spesify the shape of the ROI mask

% Create a binary image ("mask") from the ROI object.
binaryImage = createMask(h);

% Display the mask
figure(100)
imshow(binaryImage);
title('Binary mask of the region');

% Mask the image and display it.
% Will keep only the part of the image that's inside the mask, zero outside mask.
blackMaskedImage = frame;
blackMaskedImage(~binaryImage) = 255;
figure(101)
imshow(blackMaskedImage);
title('Masked Outside Region');
frame = blackMaskedImage(:,:,1);

%%
display_fps = 25;                        %%- INPUT -%% Displayed frame rate of the video
recorded_fps = 60;                       %%- INPUT -%% Actual frame rate that the camera recorded at

PT = 24; % INPUT % Spesify the time of the video where the SAW is initiated

frames_to_save = display_fps*(PT:30*recorded_fps/display_fps:PT+330*recorded_fps/display_fps); % INPUT %  Spesify time gap between each saved frame (here 30 sec) and the last time frame (here 330 sec)
pre_time_trigger = frames_to_save(1)/recorded_fps; % real trigger time [s]  

for i = 1:length(frames_to_save)
    frame_number = frames_to_save(i);
    frame = read(a,frame_number);
    
    % OPTIOINAL: Adjust the illlumination
    % frame = rgb2gray(frame);
    % frame = frame * 1.5;


    % Mask the image and display it.
    % Will keep only the part of the image that's inside the mask, zero outside mask.
    blackMaskedImage = frame;
    blackMaskedImage(~binaryImage) = 255;
    frame = blackMaskedImage(:,:,1);

    
    % -------  Plot, write text and save the images  ----------------- %

    time = a.CurrentTime;  % time at the spesific frame
    position = [70 70;1625 1100];
    time_text = ['time: ' num2str(time*display_fps/recorded_fps - pre_time_trigger) 'sec'];
    text2 = {time_text,'0.5 mm'};
    %RGB = insertText(frame,[100 100],['time: ' num2str(time/5 - pre_time_trigger) 'sec'],FontSize=50,BoxColor='black', BoxOpacity=0.4,TextColor="white");
    RGB = insertText(frame, position,text2,FontSize=80,BoxColor=[255 255 255], BoxOpacity=0.4,TextColor="black");
    RGB2 = insertShape(RGB,'Line',[1660 1220 1954.1 1220],'LineWidth',13,'Color','black');
    figure(2)
    imshow(RGB2)
    image_name = append(save_name,'_REAL_ACTUATION_time_',num2str(time*display_fps/recorded_fps - pre_time_trigger),'sec.png');
    imwrite(RGB2, string(image_name));

    %     % -----  Use this for four image comparison in the thesis [Difference : Larger text size]   ------- %
%     time = a.CurrentTime;  % time at the spesific frame
%     position = [30 30;1500 1040];
%     time_text = ['time: ' num2str(time*display_fps/recorded_fps - pre_time_trigger) 'sec'];
%     text2 = {time_text,'0.5 mm'};
%     RGB = insertText(frame, position,text2,FontSize=110,BoxColor=[255 255 255], BoxOpacity=0.4,TextColor="black");
%     RGB2 = insertShape(RGB,'Line',[1600 1220 1894.1 1220],'LineWidth',13,'Color','black');
%     figure(2)
%     imshow(RGB2)
%     image_name = append(save_name,'_REAL_ACTUATION_time_',num2str(time*display_fps/recorded_fps - pre_time_trigger),'sec.png');
%     imwrite(RGB2, string(image_name));

end