close all
clear all
clc
%% Import video

path = 'D:\NTNU\10. Semester - MASTER\Spiral IDT\';
file = [path '20MHz-Exp46_26042023_20MHz_2uL_7ump_conc_1_5_100mW_4xMag_125fps.mp4'];
vid = VideoReader(file)
f = 25*48;  % INPUT % Spesify the timeframe to analyse

% This script is written for the experiments recorded at 125 fps

image = read(vid,f);
time = vid.CurrentTime;
frames = vid.NumFrames;

figure(1)
imshow(image)
title("Spesify the concentric rings along the line: Frame at timestep "+ num2str(time) +" s (video time) = "+num2str(time*25/10)+" s (real time including trigger time)")
hold on
% x- line :
plot([992 0], [530 530],"--",'color','r')  % INPUT % Spesify the position of the red dotted line 
% y- line :
%plot([1000 1000], [0 1264],"--",'color','r')
%hold off

set(gcf, 'Position', get(0,'Screensize')); % Maximize figure.
message = sprintf('Click on image.\nEnter to finish');
uiwait(msgbox(message));
[xi_cal,yi_cal] = getpts;
close

%% Calibration

% AOS camera:
path = 'C:\Users\bjornmq\OneDrive - NTNU\10. Semester NTNU - Master TEP4926\05 Experimenter\Calibration_Images_14032023\FC_4xMag_500umGrid_14032023.png';

% PHOTRON High speed camera:
%cal_image = imread('C:\Users\bjornmq\OneDrive - NTNU\10. Semester NTNU - Master TEP4926\05 Experimenter\Calibration 500um HighSpeedCamera.tif'); 

ratio = Calibration(path) % um/px ratio

%% Calculating Spacing

distance = [];

% Loop over the elements in the array and compute the differences
for i = 1:length(xi_cal)-1
    diff = sqrt((xi_cal(i+1) - xi_cal(i))^2 + (yi_cal(i+1) - yi_cal(i))^2);
    distance(end+1) = abs(diff)*ratio;
end

display("Distance in direction:")
display(distance)
mean_Dist = mean(distance)
StDev_Dist = std(distance)
